/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.58 Revision 1.98
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.58 2007/01/04 20:38:16 vivo Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.98 2008/11/14 01:46:24 robbat2 Exp $
4# kate: encoding utf-8; eol unix;
5# kate: indent-width 4; mixedindent off; remove-trailing-space on; space-indent off;
6# kate: word-wrap-column 80; word-wrap off;
7 4
8# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 5# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
6# Maintainer: MySQL Team <mysql-bugs@gentoo.org>
9# Maintainer: Luca Longinotti <chtekk@gentoo.org> 7# - Luca Longinotti <chtekk@gentoo.org>
8# - Robin H. Johnson <robbat2@gentoo.org>
10 9
11# Note that MYSQL_VERSION_ID must be empty !!! 10WANT_AUTOCONF="latest"
11WANT_AUTOMAKE="latest"
12 12
13ECLASS="mysql"
14INHERITED="$INHERITED $ECLASS"
15inherit eutils flag-o-matic gnuconfig autotools mysql_fx 13inherit eutils flag-o-matic gnuconfig autotools mysql_fx
16 14
17# avoid running userspace code 8 times per ebuild :( 15# Shorten the path because the socket path length must be shorter than 107 chars
18if [[ "${_MYPVR}" != "${PVR}" ]] && [[ -n "${PVR}" ]] 16# and we will run a mysql server during test phase
19then 17S="${WORKDIR}/mysql"
20 _MYPVR=${PVR}
21 18
22 [[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070104" 19[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20070108"
20if [[ "${MY_EXTRAS_VER}" == "live" ]]; then
21 EGIT_PROJECT=mysql-extras
22 EGIT_REPO_URI="git://git.overlays.gentoo.org/proj/mysql-extras.git"
23 inherit git
24fi
23 25
24 if [[ ${PR#r} -lt 60 ]] ; then 26if [[ ${PR#r} -lt 60 ]] ; then
25 IS_BITKEEPER=0 27 IS_BITKEEPER=0
26 elif [[ ${PR#r} -lt 90 ]] ; then 28elif [[ ${PR#r} -lt 90 ]] ; then
27 IS_BITKEEPER=60 29 IS_BITKEEPER=60
28 else 30else
29 IS_BITKEEPER=90 31 IS_BITKEEPER=90
30 fi 32fi
31 33
32 # MYSQL_VERSION_ID will be: 34# MYSQL_VERSION_ID will be:
33 # major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 35# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
34 # This is an important part, because many of the choices the MySQL ebuild will do 36# This is an important part, because many of the choices the MySQL ebuild will do
35 # depend on this variable. 37# depend on this variable.
36 # In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803" 38# In particular, the code below transforms a $PVR like "5.0.18-r3" in "5001803"
39# We also strip off upstream's trailing letter that they use to respin tarballs
40
37 MYSQL_VERSION_ID="" 41MYSQL_VERSION_ID=""
42tpv="${PV%[a-z]}"
38 tpv=( ${PV//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}" 43tpv=( ${tpv//[-._]/ } ) ; tpv[3]="${PVR:${#PV}}" ; tpv[3]="${tpv[3]##*-r}"
39 for vatom in 0 1 2 3 ; do 44for vatom in 0 1 2 3 ; do
40 # pad to length 2 45 # pad to length 2
41 tpv[${vatom}]="00${tpv[${vatom}]}" 46 tpv[${vatom}]="00${tpv[${vatom}]}"
42 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}" 47 MYSQL_VERSION_ID="${MYSQL_VERSION_ID}${tpv[${vatom}]:0-2}"
43 done 48done
44 # strip leading "0" (otherwise it's considered an octal number by BASH) 49# strip leading "0" (otherwise it's considered an octal number by BASH)
45 MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"} 50MYSQL_VERSION_ID=${MYSQL_VERSION_ID##"0"}
46 51
47 # Be warned, *DEPEND are version-dependant 52# Be warned, *DEPEND are version-dependant
53# These are used for both runtime and compiletime
48 DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d ) 54DEPEND="ssl? ( >=dev-libs/openssl-0.9.6d )
49 userland_GNU? ( sys-process/procps ) 55 userland_GNU? ( sys-process/procps )
50 >=sys-apps/sed-4 56 >=sys-apps/sed-4
51 >=sys-apps/texinfo-4.7-r1 57 >=sys-apps/texinfo-4.7-r1
52 >=sys-libs/readline-4.1 58 >=sys-libs/readline-4.1
53 >=sys-libs/zlib-1.2.3 59 >=sys-libs/zlib-1.2.3"
54 "
55 60
56 # having different flavours at the same time is not a good idea 61# Having different flavours at the same time is not a good idea
57 for i in "" "-community" "-slotted" ; do 62for i in "" "-community" ; do
58 [[ "${i}" == ${PN#mysql} ]] || 63 [[ "${i}" == ${PN#mysql} ]] ||
59 DEPEND="${DEPEND} !dev-db/mysql${i}" 64 DEPEND="${DEPEND} !dev-db/mysql${i}"
60 done 65done
61 66
67RDEPEND="${DEPEND}
68 !minimal? ( dev-db/mysql-init-scripts )
69 selinux? ( sec-policy/selinux-mysql )"
70
71# compile-time-only
62 mysql_version_is_at_least "5.1" \ 72mysql_version_is_at_least "5.1" \
63 || DEPEND="${DEPEND} berkdb? ( sys-apps/ed )" 73|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
64 74
65 # dev-perl/DBD-mysql is needed by some scripts installed by MySQL 75# compile-time-only
66 PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
67
68 if mysql_version_is_at_least "5.1.12" ; then 76mysql_version_is_at_least "5.1.12" \
69 DEPEND="${DEPEND} innodb? ( >=dev-util/cmake-2.4.3 )" 77&& DEPEND="${DEPEND} innodb? ( >=dev-util/cmake-2.4.3 )"
70 fi
71 78
72 # Shorten the path because the socket path length must be shorter than 107 chars
73 # and we will run a mysql server during test phase
74 S="${WORKDIR}/mysql"
75
76 # BitKeeper dependency, compile-time only 79# BitKeeper dependency, compile-time only
77 [[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client" 80[[ ${IS_BITKEEPER} -eq 90 ]] && DEPEND="${DEPEND} dev-util/bk_client"
78 81
82
83# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
84PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
85
86# Work out the default SERVER_URI correctly
87if [ -z "${SERVER_URI}" ]; then
88 # The community build is on the mirrors
89 if [ "${PN}" == "mysql-community" ]; then
90 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${PV//_/-}.tar.gz"
91 # The enterprise source is on the primary site only
79 if [[ ${PN} == "mysql-slotted" ]] ; then 92 elif [ "${PN}" == "mysql" ]; then
80 DEPEND="${DEPEND} app-admin/eselect-mysql" 93 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${PV//_/-}.tar.gz"
94 fi
81 fi 95fi
82 96
83 if [[ ${PN} == "mysql-slotted" ]] ; then
84 SLOT=""
85 tpv=( ${PV//[-._]/ } )
86 for vatom in 0 1 2 ; do
87 SLOT="${SLOT}${tpv[${vatom}]}_"
88 done
89 #finally SLOT=5_0_24
90 SLOT=${SLOT:0:${#SLOT}-1}
91 else
92 SLOT="0"
93 fi
94
95 # Define correct SRC_URIs 97# Define correct SRC_URIs
96 SRC_URI=" 98SRC_URI="${SERVER_URI}"
97 ${SERVER_URI} 99
100[[ ${MY_EXTRAS_VER} != live ]] && SRC_URI="${SRC_URI}
101 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
98 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 102 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
99 "
100 mysql_version_is_at_least "5.1.12" \ 103mysql_version_is_at_least "5.1.12" \
101 && [[ -n "${PBXT_VERSION}" ]] \ 104&& [[ -n "${PBXT_VERSION}" ]] \
102 && SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )" 105&& SRC_URI="${SRC_URI} pbxt? ( mirror://sourceforge/pbxt/pbxt-${PBXT_VERSION}.tar.gz )"
103 106
104 DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 107DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
105 HOMEPAGE="http://www.mysql.com/" 108HOMEPAGE="http://www.mysql.com/"
106 LICENSE="GPL-2" 109LICENSE="GPL-2"
110SLOT="0"
107 IUSE="big-tables debug embedded minimal perl selinux ssl static" 111IUSE="big-tables debug embedded minimal perl selinux ssl static"
108 RESTRICT="confcache"
109 112
110 mysql_version_is_at_least "4.1" \ 113mysql_version_is_at_least "4.1" \
111 && IUSE="${IUSE} latin1" 114&& IUSE="${IUSE} latin1"
112 115
113 mysql_version_is_at_least "4.1.3" \ 116mysql_version_is_at_least "4.1.3" \
114 && IUSE="${IUSE} cluster extraengine" 117&& IUSE="${IUSE} cluster extraengine"
115 118
116 mysql_version_is_at_least "5.0" \ 119mysql_version_is_at_least "5.0" \
117 || IUSE="${IUSE} raid" 120|| IUSE="${IUSE} raid"
118 121
119 mysql_version_is_at_least "5.0.18" \ 122mysql_version_is_at_least "5.0.18" \
120 && IUSE="${IUSE} max-idx-128" 123&& IUSE="${IUSE} max-idx-128"
121 124
122 mysql_version_is_at_least "5.1" \ 125mysql_version_is_at_least "5.1" \
123 && IUSE="${IUSE} innodb" 126&& IUSE="${IUSE} innodb"
124 127
125 mysql_version_is_at_least "5.1" \ 128mysql_version_is_at_least "5.1" \
126 || IUSE="${IUSE} berkdb" 129|| IUSE="${IUSE} berkdb"
127 130
128 mysql_version_is_at_least "5.1.12" \ 131mysql_version_is_at_least "5.1.12" \
129 && IUSE="${IUSE} pbxt" 132&& IUSE="${IUSE} pbxt"
130
131 RDEPEND="${DEPEND}
132 sys-apps/mysql
133 selinux? ( sec-policy/selinux-mysql )
134 "
135
136fi # if [[ "${_MYPVR}" != "${PVR}" ]]
137 133
138EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \ 134EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_preinst \
139 pkg_postinst pkg_config pkg_postrm 135 pkg_postinst pkg_config pkg_postrm
140 136
141# 137#
142# HELPER FUNCTIONS: 138# HELPER FUNCTIONS:
143# 139#
144 140
145bitkeeper_fetch() { 141bitkeeper_fetch() {
146
147 local reposuf 142 local reposuf
148 if [[ -z "${1}" ]] ; then 143 if [[ -z "${1}" ]] ; then
149 local tpv 144 local tpv
150 tpv=( ${PV//[-._]/ } ) 145 tpv=( ${PV//[-._]/ } )
151 reposuf="mysql-${tpv[0]}.${tpv[1]}" 146 reposuf="mysql-${tpv[0]}.${tpv[1]}"
152 else 147 else
153 reposuf="${1}" 148 reposuf="${1}"
154 fi 149 fi
155 einfo "using \"${reposuf}\" repository." 150 einfo "Using '${reposuf}' repository."
156 local repo_uri="bk://mysql.bkbits.net/${reposuf}" 151 local repo_uri="bk://mysql.bkbits.net/${reposuf}"
157 ## -- ebk_store_dir: bitkeeper sources store directory 152 ## -- ebk_store_dir: bitkeeper sources store directory
158 local ebk_store_dir="${PORTAGE_ACTUAL_DISTDIR-${DISTDIR}}/bk-src" 153 local ebk_store_dir="${PORTAGE_ACTUAL_DISTDIR-${DISTDIR}}/bk-src"
159 ## -- ebk_fetch_cmd: bitkeeper fetch command 154 ## -- ebk_fetch_cmd: bitkeeper fetch command
160 # always fetch the latest revision, use -r<revision> if a specified revision is wanted 155 # always fetch the latest revision, use -r<revision> if a specified revision is wanted
161 # hint: does not work 156 # hint: does not work
162 local ebk_fetch_cmd="sfioball" 157 local ebk_fetch_cmd="sfioball"
163 ## -- ebk_update_cmd: bitkeeper update command 158 ## -- ebk_update_cmd: bitkeeper update command
164 local ebk_update_cmd="update" 159 local ebk_update_cmd="update"
165 160
166 #addread "/etc/bitkeeper" 161 # addread "/etc/bitkeeper"
167 addwrite "${ebk_store_dir}" 162 addwrite "${ebk_store_dir}"
168 163
169 if [[ ! -d "${ebk_store_dir}" ]]; then 164 if [[ ! -d "${ebk_store_dir}" ]] ; then
170 debug-print "${FUNCNAME}: initial checkout. creating bitkeeper directory" 165 debug-print "${FUNCNAME}: initial checkout, creating bitkeeper directory ..."
171 mkdir -p "${ebk_store_dir}" || die "${EBK}: can't mkdir ${ebk_store_dir}." 166 mkdir -p "${ebk_store_dir}" || die "BK: couldn't mkdir ${ebk_store_dir}"
172 fi 167 fi
173 168
174 pushd "${ebk_store_dir}" || die "${EBK}: can't chdir to ${ebk_store_dir}" 169 pushd "${ebk_store_dir}" || die "BK: couldn't chdir to ${ebk_store_dir}"
175 170
176 local wc_path=${reposuf} 171 local wc_path=${reposuf}
177 172
178 if [[ ! -d "${wc_path}" ]]; then 173 if [[ ! -d "${wc_path}" ]] ; then
179 local options="-r+" 174 local options="-r+"
175
180 # first check out 176 # first checkout
181 einfo "bitkeeper check out start -->" 177 einfo "bitkeeper checkout start -->"
182 einfo " repository: ${repo_uri}" 178 einfo " repository: ${repo_uri}"
179
183 ${ebk_fetch_cmd} ${options} "${repo_uri}" ${wc_path} \ 180 ${ebk_fetch_cmd} ${options} "${repo_uri}" "${wc_path}" \
184 || die "${EBK}: can't fetch from ${repo_uri}." 181 || die "BK: couldn't fetch from ${repo_uri}"
185 else 182 else
186 if [[ ! -d "${wc_path}/BK" ]]; then 183 if [[ ! -d "${wc_path}/BK" ]] ; then
187 popd 184 popd
188 die "Look like ${wc_path} is not a bitkeeper path." 185 die "Looks like ${wc_path} is not a bitkeeper path"
189 fi 186 fi
190 187
191 # update working copy 188 # update working copy
192 einfo "bitkeeper update start -->" 189 einfo "bitkeeper update start -->"
193 einfo " repository: ${repo_uri}" 190 einfo " repository: ${repo_uri}"
194 191
195 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \ 192 ${ebk_update_cmd} "${repo_uri}" "${wc_path}" \
196 || die "BK: can't update from ${repo_uri} to ${wc_path}." 193 || die "BK: couldn't update from ${repo_uri} to ${wc_path}"
197 fi 194 fi
198 195
199 einfo " working copy: ${wc_path}" 196 einfo " working copy: ${wc_path}"
200 cd "${wc_path}" 197 cd "${wc_path}"
201 rsync -rlpgo --exclude="BK/" . "${S}" || die "BK: can't export to ${S}." 198 rsync -rlpgo --exclude="BK/" . "${S}" || die "BK: couldn't export to ${S}"
202 199
203 echo 200 echo
204 popd 201 popd
205
206} 202}
207 203
208mysql_disable_test() { 204mysql_disable_test() {
209 local testname="${1}" ; shift 205 local testname="${1}" ; shift
210 local reason="${@}" 206 local reason="${@}"
211 local mysql_disable_file="${S}/mysql-test/t/disabled.def" 207 local mysql_disable_file="${S}/mysql-test/t/disabled.def"
212 echo ${testname} : ${reason} >> "${mysql_disable_file}" 208 echo ${testname} : ${reason} >> "${mysql_disable_file}"
213 ewarn "test \"${testname}\" disabled because: \"${reason}\"" 209 ewarn "test '${testname}' disabled: '${reason}'"
214} 210}
215 211
216# void mysql_init_vars() 212# void mysql_init_vars()
217# 213#
218# Initialize global variables 214# Initialize global variables
219# 2005-11-19 <vivo@gentoo.org> 215# 2005-11-19 <vivo@gentoo.org>
220 216
221mysql_init_vars() { 217mysql_init_vars() {
222 if [[ ${SLOT} == "0" ]] ; then
223 MY_SUFFIX=""
224 else
225 MY_SUFFIX=${MY_SUFFIX:-"-${SLOT}"}
226 fi
227 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR:-"/usr/share/mysql${MY_SUFFIX}"} 218 MY_SHAREDSTATEDIR=${MY_SHAREDSTATEDIR="/usr/share/mysql"}
228 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql${MY_SUFFIX}"} 219 MY_SYSCONFDIR=${MY_SYSCONFDIR="/etc/mysql"}
229 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql${MY_SUFFIX}"} 220 MY_LIBDIR=${MY_LIBDIR="/usr/$(get_libdir)/mysql"}
230 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql${MY_SUFFIX}"} 221 MY_LOCALSTATEDIR=${MY_LOCALSTATEDIR="/var/lib/mysql"}
231 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql${MY_SUFFIX}"} 222 MY_LOGDIR=${MY_LOGDIR="/var/log/mysql"}
232 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql${MY_SUFFIX}"} 223 MY_INCLUDEDIR=${MY_INCLUDEDIR="/usr/include/mysql"}
233 224
234 if [[ -z "${DATADIR}" ]] ; then 225 if [[ -z "${MY_DATADIR}" ]] ; then
235 DATADIR="" 226 MY_DATADIR=""
236 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then 227 if [[ -f "${MY_SYSCONFDIR}/my.cnf" ]] ; then
237 DATADIR=`"my_print_defaults${MY_SUFFIX}" mysqld 2>/dev/null \ 228 MY_DATADIR=`"my_print_defaults" mysqld 2>/dev/null \
238 | sed -ne '/datadir/s|^--datadir=||p' \ 229 | sed -ne '/datadir/s|^--datadir=||p' \
239 | tail -n1` 230 | tail -n1`
240 if [[ -z "${DATADIR}" ]] ; then 231 if [[ -z "${MY_DATADIR}" ]] ; then
241 DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \ 232 MY_DATADIR=`grep ^datadir "${MY_SYSCONFDIR}/my.cnf" \
242 | sed -e 's/.*=\s*//'` 233 | sed -e 's/.*=\s*//' \
234 | tail -n1`
243 fi 235 fi
244 fi 236 fi
245 if [[ -z "${DATADIR}" ]] ; then 237 if [[ -z "${MY_DATADIR}" ]] ; then
246 DATADIR="${MY_LOCALSTATEDIR}" 238 MY_DATADIR="${MY_LOCALSTATEDIR}"
247 einfo "Using default DATADIR" 239 einfo "Using default MY_DATADIR"
248 fi 240 fi
249 elog "MySQL DATADIR is ${DATADIR}" 241 elog "MySQL MY_DATADIR is ${MY_DATADIR}"
250 242
251 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then 243 if [[ -z "${PREVIOUS_DATADIR}" ]] ; then
252 if [[ -e "${DATADIR}" ]] ; then 244 if [[ -e "${MY_DATADIR}" ]] ; then
253 elog "Previous datadir found, it's YOUR job to change" 245 # If you get this and you're wondering about it, see bug #207636
254 elog "ownership and take care of it" 246 elog "MySQL datadir found in ${MY_DATADIR}"
247 elog "A new one will not be created."
255 PREVIOUS_DATADIR="yes" 248 PREVIOUS_DATADIR="yes"
256 else 249 else
257 PREVIOUS_DATADIR="no" 250 PREVIOUS_DATADIR="no"
258 fi 251 fi
259 export PREVIOUS_DATADIR 252 export PREVIOUS_DATADIR
261 fi 254 fi
262 255
263 MY_SOURCEDIR=${SERVER_URI##*/} 256 MY_SOURCEDIR=${SERVER_URI##*/}
264 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*} 257 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
265 258
266 export MY_SUFFIX MY_SHAREDSTATEDIR MY_SYSCONFDIR 259 export MY_SHAREDSTATEDIR MY_SYSCONFDIR
267 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 260 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
268 export MY_INCLUDEDIR DATADIR MY_SOURCEDIR 261 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR
269} 262}
270 263
271configure_minimal() { 264configure_minimal() {
272 # These are things we exclude from a minimal build, please 265 # These are things we exclude from a minimal build, please
273 # note that the server actually does get built and installed, 266 # note that the server actually does get built and installed,
274 # but we then delete it before packaging. 267 # but we then delete it before packaging.
275 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication" 268 local minimal_exclude_list="server embedded-server extra-tools innodb bench berkeley-db row-based-replication readline"
276 269
277 for i in ${minimal_exclude_list} ; do 270 for i in ${minimal_exclude_list} ; do
278 myconf="${myconf} --without-${i}" 271 myconf="${myconf} --without-${i}"
279 done 272 done
280 myconf="${myconf} --with-extra-charsets=none" 273 myconf="${myconf} --with-extra-charsets=none"
281 myconf="${myconf} --enable-local-infile" 274 myconf="${myconf} --enable-local-infile"
282 275
283 if useq "static" ; then 276 if use static ; then
284 myconf="${myconf} --with-client-ldflags=-all-static" 277 myconf="${myconf} --with-client-ldflags=-all-static"
285 myconf="${myconf} --disable-shared" 278 myconf="${myconf} --disable-shared --with-pic"
286 else 279 else
287 myconf="${myconf} --enable-shared --enable-static" 280 myconf="${myconf} --enable-shared --enable-static"
288 fi 281 fi
289 282
290 if mysql_version_is_at_least "4.01.00.00" && ! useq "latin1" ; then 283 if mysql_version_is_at_least "4.1" && ! use latin1 ; then
291 myconf="${myconf} --with-charset=utf8" 284 myconf="${myconf} --with-charset=utf8"
292 myconf="${myconf} --with-collation=utf8_general_ci" 285 myconf="${myconf} --with-collation=utf8_general_ci"
293 else 286 else
294 myconf="${myconf} --with-charset=latin1" 287 myconf="${myconf} --with-charset=latin1"
295 myconf="${myconf} --with-collation=latin1_swedish_ci" 288 myconf="${myconf} --with-collation=latin1_swedish_ci"
303 myconf="${myconf} --with-mysqld-user=mysql" 296 myconf="${myconf} --with-mysqld-user=mysql"
304 myconf="${myconf} --with-server" 297 myconf="${myconf} --with-server"
305 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock" 298 myconf="${myconf} --with-unix-socket-path=/var/run/mysqld/mysqld.sock"
306 myconf="${myconf} --without-libwrap" 299 myconf="${myconf} --without-libwrap"
307 300
308 if useq "static" ; then 301 if use static ; then
309 myconf="${myconf} --with-mysqld-ldflags=-all-static" 302 myconf="${myconf} --with-mysqld-ldflags=-all-static"
310 myconf="${myconf} --with-client-ldflags=-all-static" 303 myconf="${myconf} --with-client-ldflags=-all-static"
311 myconf="${myconf} --disable-shared" 304 myconf="${myconf} --disable-shared --with-pic"
312 else 305 else
313 myconf="${myconf} --enable-shared --enable-static" 306 myconf="${myconf} --enable-shared --enable-static"
314 fi 307 fi
315 308
316 if useq "debug" ; then 309 if use debug ; then
317 myconf="${myconf} --with-debug=full" 310 myconf="${myconf} --with-debug=full"
318 else 311 else
319 myconf="${myconf} --without-debug" 312 myconf="${myconf} --without-debug"
320 mysql_version_is_at_least "4.1.3" \ 313 mysql_version_is_at_least "4.1.3" \
321 && useq "cluster" \ 314 && use cluster \
322 && myconf="${myconf} --without-ndb-debug" 315 && myconf="${myconf} --without-ndb-debug"
323 fi 316 fi
324 317
325 if mysql_version_is_at_least "4.1" && ! useq "latin1" ; then 318 if mysql_version_is_at_least "4.1" && ! use latin1 ; then
326 myconf="${myconf} --with-charset=utf8" 319 myconf="${myconf} --with-charset=utf8"
327 myconf="${myconf} --with-collation=utf8_general_ci" 320 myconf="${myconf} --with-collation=utf8_general_ci"
328 else 321 else
329 myconf="${myconf} --with-charset=latin1" 322 myconf="${myconf} --with-charset=latin1"
330 myconf="${myconf} --with-collation=latin1_swedish_ci" 323 myconf="${myconf} --with-collation=latin1_swedish_ci"
331 fi 324 fi
332 325
333 if useq "embedded" ; then 326 if use embedded ; then
334 myconf="${myconf} --with-embedded-privilege-control" 327 myconf="${myconf} --with-embedded-privilege-control"
335 myconf="${myconf} --with-embedded-server" 328 myconf="${myconf} --with-embedded-server"
336 else 329 else
337 myconf="${myconf} --without-embedded-privilege-control" 330 myconf="${myconf} --without-embedded-privilege-control"
338 myconf="${myconf} --without-embedded-server" 331 myconf="${myconf} --without-embedded-server"
346 myconf="${myconf} --with-extra-tools" 339 myconf="${myconf} --with-extra-tools"
347 myconf="${myconf} --with-innodb" 340 myconf="${myconf} --with-innodb"
348 myconf="${myconf} --without-readline" 341 myconf="${myconf} --without-readline"
349 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)" 342 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
350 343
351 if useq "ssl" ; then
352 # --with-vio is not needed anymore, it's on by default and 344 # --with-vio is not needed anymore, it's on by default and
353 # has been removed from configure 345 # has been removed from configure
346 if use ssl ; then
354 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio" 347 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
348 fi
349
350 if mysql_version_is_at_least "5.1.11" ; then
351 myconf="${myconf} $(use_with ssl)"
352 else
353 myconf="${myconf} $(use_with ssl openssl)"
354 fi
355
355 if mysql_version_is_at_least "5.0.6" ; then 356 if mysql_version_is_at_least "5.0.60" ; then
356 # myconf="${myconf} --with-yassl" 357 if use berkdb ; then
358 elog "Berkeley DB support was disabled due to build failures"
359 elog "on multiple arches, go to a version earlier than 5.0.60"
360 elog "if you want it again. Gentoo bug #224067."
361 fi
357 myconf="${myconf} --with-ssl" 362 myconf="${myconf} --without-berkeley-db"
363 elif use berkdb ; then
364 # The following fix is due to a bug with bdb on SPARC's. See:
365 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
366 # It comes down to non-64-bit safety problems.
367 if use alpha || use amd64 || use hppa || use mips || use sparc ; then
368 elog "Berkeley DB support was disabled due to compatibility issues on this arch"
369 myconf="${myconf} --without-berkeley-db"
358 else 370 else
359 myconf="${myconf} --with-openssl" 371 myconf="${myconf} --with-berkeley-db=./bdb"
360 fi
361 else
362 myconf="${myconf} --without-openssl"
363 fi 372 fi
364 373 else
365 # The following fix is due to a bug with bdb on SPARC's. See:
366 # http://www.geocrawler.com/mail/msg.php3?msg_id=4754814&list=8
367 # It comes down to non-64-bit safety problems.
368 if useq "sparc" || useq "alpha" || useq "hppa" || useq "mips" || useq "amd64" ; then
369 elog "Berkeley DB support was disabled due to incompatible arch"
370 myconf="${myconf} --without-berkeley-db" 374 myconf="${myconf} --without-berkeley-db"
371 else
372 if useq "berkdb" ; then
373 myconf="${myconf} --with-berkeley-db=./bdb"
374 else
375 myconf="${myconf} --without-berkeley-db"
376 fi
377 fi 375 fi
378 376
379 if mysql_version_is_at_least "4.1.3" ; then 377 if mysql_version_is_at_least "4.1.3" ; then
380 myconf="${myconf} --with-geometry" 378 myconf="${myconf} --with-geometry"
381 myconf="${myconf} $(use_with cluster ndbcluster)" 379 myconf="${myconf} $(use_with cluster ndbcluster)"
382 fi 380 fi
383 381
384 if mysql_version_is_at_least "4.1.3" && useq "extraengine" ; then 382 if mysql_version_is_at_least "4.1.3" && use extraengine ; then
385 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 383 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
386 myconf="${myconf} --with-archive-storage-engine" 384 myconf="${myconf} --with-archive-storage-engine"
387 385
388 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html 386 # http://dev.mysql.com/doc/mysql/en/csv-storage-engine.html
389 myconf="${myconf} --with-csv-storage-engine" 387 myconf="${myconf} --with-csv-storage-engine"
400 myconf="${myconf} --with-federated-storage-engine" 398 myconf="${myconf} --with-federated-storage-engine"
401 fi 399 fi
402 fi 400 fi
403 401
404 mysql_version_is_at_least "5.0.18" \ 402 mysql_version_is_at_least "5.0.18" \
405 && useq "max-idx-128" \ 403 && use max-idx-128 \
406 && myconf="${myconf} --with-max-indexes=128" 404 && myconf="${myconf} --with-max-indexes=128"
407} 405}
408 406
409configure_51() { 407configure_51() {
410 # TODO: !!!! readd --without-readline 408 # TODO: !!!! readd --without-readline
415 myconf="${myconf} --with-geometry" 413 myconf="${myconf} --with-geometry"
416 myconf="${myconf} --with-readline" 414 myconf="${myconf} --with-readline"
417 myconf="${myconf} --with-row-based-replication" 415 myconf="${myconf} --with-row-based-replication"
418 myconf="${myconf} --with-zlib=/usr/$(get_libdir)" 416 myconf="${myconf} --with-zlib=/usr/$(get_libdir)"
419 myconf="${myconf} --without-pstack" 417 myconf="${myconf} --without-pstack"
420 useq "max-idx-128" && myconf="${myconf} --with-max-indexes=128" 418 use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
421 419
422 # 5.1 introduces a new way to manage storage engines (plugins) 420 # 5.1 introduces a new way to manage storage engines (plugins)
423 # like configuration=none 421 # like configuration=none
424 local plugins="csv,myisam,myisammrg,heap" 422 local plugins="csv,myisam,myisammrg,heap"
425 if useq "extraengine" ; then 423 if use extraengine ; then
426 # like configuration=max-no-ndb, archive and example removed in 5.1.11 424 # like configuration=max-no-ndb, archive and example removed in 5.1.11
427 plugins="${plugins},archive,blackhole,example,federated,partition" 425 plugins="${plugins},archive,blackhole,example,federated,partition"
428 426
429 elog "Before using the Federated storage engine, please be sure to read" 427 elog "Before using the Federated storage engine, please be sure to read"
430 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 428 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
431 fi 429 fi
432 430
433 if useq "innodb" ; then 431 if use innodb ; then
434 plugins="${plugins},innobase" 432 plugins="${plugins},innobase"
435 fi 433 fi
436 434
437 # like configuration=max-no-ndb 435 # like configuration=max-no-ndb
438 if useq "cluster" ; then 436 if use cluster ; then
439 plugins="${plugins},ndbcluster" 437 plugins="${plugins},ndbcluster"
440 myconf="${myconf} --with-ndb-binlog" 438 myconf="${myconf} --with-ndb-binlog"
441 fi 439 fi
442 440
443 if mysql_version_is_at_least "5.2" ; then 441 if mysql_version_is_at_least "5.2" ; then
453 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 451 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
454 452
455 einfo "Reconfiguring dir '${PWD}'" 453 einfo "Reconfiguring dir '${PWD}'"
456 AT_GNUCONF_UPDATE="yes" eautoreconf 454 AT_GNUCONF_UPDATE="yes" eautoreconf
457 455
458 local myconf 456 local myconf=""
459 myconf="${myconf} --with-mysql=${S}"
460 mkdir -p ${T}/lib
461 myconf="${myconf} --libdir=${D}/${MY_LIBDIR}" 457 myconf="${myconf} --with-mysql=${S} --libdir=${D}/${MY_LIBDIR}"
462 useq "debug" && myconf="${myconf} --with-debug=full" 458 use debug && myconf="${myconf} --with-debug=full"
463 # TODO is safe/needed to use econf here ? 459 # TODO: is it safe/needed to use econf here ?
464 ./configure ${myconf} || die "problem configuring pbxt storage engine" 460 ./configure ${myconf} || die "Problem configuring PBXT storage engine"
465 # TODO is safe/needed to use emake here ? 461 # TODO: is it safe/needed to use emake here ?
466 make || die "problem making pbxt storage engine (${myconf})" 462 make || die "Problem making PBXT storage engine (${myconf})"
467 463
468 popd 464 popd
469 # TODO: modify test suite 465 # TODO: modify test suite for PBXT
470} 466}
471 467
472pbxt_src_install() { 468pbxt_src_install() {
473 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 469 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
474 make install || die "failed pbxt install" 470 make install || die "Failed to install PBXT"
475 popd 471 popd
476} 472}
477 473
478# 474#
479# EBUILD FUNCTIONS 475# EBUILD FUNCTIONS
480# 476#
481
482mysql_pkg_setup() { 477mysql_pkg_setup() {
483 enewgroup mysql 60 || die "problem adding 'mysql' group" 478 if hasq test ${FEATURES} ; then
484 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 479 if ! use minimal ; then
480 if [[ $UID -eq 0 ]]; then
481 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root."
482 fi
483 fi
484 fi
485
486 # Bug #213475 - MySQL _will_ object strenously if your machine is named
487 # localhost. Also causes weird failures.
488 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost"
485 489
486 # Check for USE flag problems in pkg_setup 490 # Check for USE flag problems in pkg_setup
487 if useq "static" && useq "ssl" ; then 491 if use static && use ssl ; then
488 eerror "MySQL does not support being built statically with SSL support enabled!" 492 eerror "MySQL does not support being built statically with SSL support enabled!"
489 die "MySQL does not support being built statically with SSL support enabled!" 493 die "MySQL does not support being built statically with SSL support enabled!"
490 fi 494 fi
491 495
492 if ! mysql_version_is_at_least "5.0" \ 496 if ! mysql_version_is_at_least "5.0" \
493 && useq "raid" \ 497 && use raid \
494 && useq "static" ; then 498 && use static ; then
495 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically" 499 eerror "USE flags 'raid' and 'static' conflict, you cannot build MySQL statically"
496 eerror "with RAID support enabled." 500 eerror "with RAID support enabled."
497 die "USE flags 'raid' and 'static' conflict!" 501 die "USE flags 'raid' and 'static' conflict!"
498 fi 502 fi
499 503
500 if mysql_version_is_at_least "4.1.3" \ 504 if mysql_version_is_at_least "4.1.3" \
501 && ( useq "cluster" || useq "extraengine" ) \ 505 && ( use cluster || use extraengine ) \
502 && useq "minimal" ; then 506 && use minimal ; then
503 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 507 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
504 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 508 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
505 fi 509 fi
510
511 # This should come after all of the die statements
512 enewgroup mysql 60 || die "problem adding 'mysql' group"
513 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
506 514
507 mysql_check_version_range "4.0 to 5.0.99.99" \ 515 mysql_check_version_range "4.0 to 5.0.99.99" \
508 && useq "berkdb" \ 516 && use berkdb \
509 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 517 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
510} 518}
511 519
512mysql_src_unpack() { 520mysql_src_unpack() {
513 # Initialize the proper variables first 521 # Initialize the proper variables first
514 mysql_init_vars 522 mysql_init_vars
515 523
516 unpack ${A} 524 unpack ${A}
525 # Grab the patches
526 [[ "${MY_EXTRAS_VER}" == "live" ]] && S="${WORKDIR}/mysql-extras" git_src_unpack
527 # Bitkeeper checkout support
517 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then 528 if [[ ${IS_BITKEEPER} -eq 90 ]] ; then
518 if mysql_check_version_range "5.1 to 5.1.99" ; then 529 if mysql_check_version_range "5.1 to 5.1.99" ; then
519 bitkeeper_fetch "mysql-5.1-ndb" 530 bitkeeper_fetch "mysql-5.1-ndb"
520 elif mysql_check_version_range "5.2.0 to 5.2.99" ; then 531 elif mysql_check_version_range "5.2 to 5.2.99" ; then
521 bitkeeper_fetch "mysql-5.2-falcon" 532 bitkeeper_fetch "mysql-5.2-falcon"
522 else 533 else
523 bitkeeper_fetch 534 bitkeeper_fetch
524 fi 535 fi
525 cd "${S}" 536 cd "${S}"
526 einfo "running upstream autorun on bk sources" 537 einfo "Running upstream autorun over BK sources ..."
527 BUILD/autorun.sh 538 BUILD/autorun.sh
528 else 539 else
529 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}" 540 mv -f "${WORKDIR}/${MY_SOURCEDIR}" "${S}"
530 cd "${S}" 541 cd "${S}"
531 fi 542 fi
532 543
533 # Apply the patches for this MySQL version 544 # Apply the patches for this MySQL version
534 EPATCH_SUFFIX="patch" 545 EPATCH_SUFFIX="patch"
535 mkdir -p "${EPATCH_SOURCE}" || die "unable to create epatch directory" 546 mkdir -p "${EPATCH_SOURCE}" || die "Unable to create epatch directory"
547 # Clean out old items
548 rm -f "${EPATCH_SOURCE}"/*
549 # Now link in right patches
536 mysql_mv_patches 550 mysql_mv_patches
537 epatch || die "failed to apply all patches" 551 # And apply
552 epatch
538 553
539 # Additional checks, remove bundled zlib 554 # Additional checks, remove bundled zlib
540 rm -f "${S}/zlib/"*.[ch] 555 rm -f "${S}/zlib/"*.[ch]
541 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 556 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
542 rm -f "scripts/mysqlbug" 557 rm -f "scripts/mysqlbug"
557 572
558 local rebuilddirlist d 573 local rebuilddirlist d
559 574
560 if mysql_version_is_at_least "5.1.12" ; then 575 if mysql_version_is_at_least "5.1.12" ; then
561 rebuilddirlist="." 576 rebuilddirlist="."
562 # TODO IMPO! Check this with a cmake expert 577 # TODO: check this with a cmake expert
563 useq "innodb" \ 578 use innodb \
564 && cmake \ 579 && cmake \
565 -DCMAKE_C_COMPILER=$(which $(tc-getCC)) \ 580 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \
566 -DCMAKE_CXX_COMPILER=$(which $(tc-getCC)) \ 581 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \
567 "storage/innobase" 582 "storage/innobase"
568 else 583 else
569 rebuilddirlist=". innobase" 584 rebuilddirlist=". innobase"
570 fi 585 fi
571 586
575 AT_GNUCONF_UPDATE="yes" eautoreconf 590 AT_GNUCONF_UPDATE="yes" eautoreconf
576 popd &>/dev/null 591 popd &>/dev/null
577 done 592 done
578 593
579 if mysql_check_version_range "4.1 to 5.0.99.99" \ 594 if mysql_check_version_range "4.1 to 5.0.99.99" \
580 && useq "berkdb" ; then 595 && use berkdb ; then
581 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh" 596 [[ -w "bdb/dist/ltmain.sh" ]] && cp -f "ltmain.sh" "bdb/dist/ltmain.sh"
597 cp -f "/usr/share/aclocal/libtool.m4" "bdb/dist/aclocal/libtool.ac" \
598 || die "Could not copy libtool.m4 to bdb/dist/"
599 #These files exist only with libtool-2*, and need to be included.
600 if [ -f '/usr/share/aclocal/ltsugar.m4' ]; then
601 cat "/usr/share/aclocal/ltsugar.m4" >> "bdb/dist/aclocal/libtool.ac"
602 cat "/usr/share/aclocal/ltversion.m4" >> "bdb/dist/aclocal/libtool.ac"
603 cat "/usr/share/aclocal/lt~obsolete.m4" >> "bdb/dist/aclocal/libtool.ac"
604 cat "/usr/share/aclocal/ltoptions.m4" >> "bdb/dist/aclocal/libtool.ac"
605 fi
582 pushd "bdb/dist" \ 606 pushd "bdb/dist" &>/dev/null
583 && sh s_all \ 607 sh s_all \
584 || die "Failed bdb reconfigure" \ 608 || die "Failed bdb reconfigure"
585 &>/dev/null
586 popd &>/dev/null 609 popd &>/dev/null
587 fi 610 fi
588} 611}
589 612
590mysql_src_compile() { 613mysql_src_compile() {
592 mysql_init_vars 615 mysql_init_vars
593 616
594 # $myconf is modified by the configure_* functions 617 # $myconf is modified by the configure_* functions
595 local myconf="" 618 local myconf=""
596 619
597 if useq "minimal" ; then 620 if use minimal ; then
598 configure_minimal 621 configure_minimal
599 else 622 else
600 configure_common 623 configure_common
601 if mysql_version_is_at_least "5.1.10" ; then 624 if mysql_version_is_at_least "5.1.10" ; then
602 configure_51 625 configure_51
616 mysql_version_is_at_least "5.0" \ 639 mysql_version_is_at_least "5.0" \
617 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates" 640 && CXXFLAGS="${CXXFLAGS} -fno-implicit-templates"
618 export CXXFLAGS 641 export CXXFLAGS
619 642
620 econf \ 643 econf \
621 --program-suffix="${MY_SUFFIX}" \
622 --libexecdir="/usr/sbin" \ 644 --libexecdir="/usr/sbin" \
623 --sysconfdir="${MY_SYSCONFDIR}" \ 645 --sysconfdir="${MY_SYSCONFDIR}" \
624 --localstatedir="${MY_LOCALSTATEDIR}" \ 646 --localstatedir="${MY_LOCALSTATEDIR}" \
625 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 647 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
626 --libdir="${MY_LIBDIR}" \ 648 --libdir="${MY_LIBDIR}" \
637 | xargs -0 -n100 sed -i \ 659 | xargs -0 -n100 sed -i \
638 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 660 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
639 661
640 emake || die "emake failed" 662 emake || die "emake failed"
641 663
642 mysql_version_is_at_least "5.1.1" && useq "pbxt" && pbxt_src_compile 664 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_compile
643} 665}
644 666
645mysql_src_install() { 667mysql_src_install() {
646 # Make sure the vars are correctly initialized 668 # Make sure the vars are correctly initialized
647 mysql_init_vars 669 mysql_init_vars
648 670
649 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die 671 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed"
650 672
651 mysql_version_is_at_least "5.1.12" && useq "pbxt" && pbxt_src_install 673 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_install
652 674
653 insinto "${MY_INCLUDEDIR}" 675 insinto "${MY_INCLUDEDIR}"
654 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h 676 doins "${MY_INCLUDEDIR}"/my_{config,dir}.h
655 677
656 # Convenience links 678 # Convenience links
657 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlanalyze${MY_SUFFIX}" 679 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
658 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqlrepair${MY_SUFFIX}" 680 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
659 dosym "/usr/bin/mysqlcheck${MY_SUFFIX}" "/usr/bin/mysqloptimize${MY_SUFFIX}" 681 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqloptimize"
660 682
661 # Various junk (my-*.cnf moved elsewhere) 683 # Various junk (my-*.cnf moved elsewhere)
662 rm -Rf "${D}/usr/share/info" 684 rm -Rf "${D}/usr/share/info"
663 for removeme in "mysql-log-rotate" mysql.server* \ 685 for removeme in "mysql-log-rotate" mysql.server* \
664 binary-configure* my-*.cnf mi_test_all* 686 binary-configure* my-*.cnf mi_test_all*
665 do 687 do
666 rm -f "${D}"/usr/share/mysql/${removeme} 688 rm -f "${D}"/usr/share/mysql/${removeme}
667 done 689 done
668 690
669 # TODO change at Makefile-am level
670 if [[ ${PN} == "mysql-slotted" ]] ; then
671 for moveme in "mysql_fix_privilege_tables.sql" \
672 "fill_help_tables.sql" "ndb-config-2-node.ini"
673 do
674 mv -f "${D}/usr/share/mysql/${moveme}" "${D}/usr/share/mysql${MY_SUFFIX}/" 2>/dev/null
675 done
676 fi
677
678 # clean up stuff for a minimal build 691 # Clean up stuff for a minimal build
679 if useq "minimal" ; then 692 if use minimal ; then
680 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench} 693 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
681 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 694 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
682 rm -f "${D}/usr/sbin/mysqld" 695 rm -f "${D}/usr/sbin/mysqld"
683 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 696 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
684 fi 697 fi
685 698
686 if [[ ${PN} == "mysql-slotted" ]] ; then
687 local notcatched=$(ls "${D}/usr/share/mysql"/*)
688 if [[ -n "${notcatched}" ]] ; then
689 ewarn "QA notice"
690 ewarn "${notcatched} files in /usr/share/mysql"
691 ewarn "bug mysql-herd to manage them"
692 fi
693 rm -Rf "${D}/usr/share/mysql"
694 fi
695
696 # Configuration stuff 699 # Configuration stuff
697 if mysql_version_is_at_least "4.1" ; then 700 if mysql_version_is_at_least "4.1" ; then
698 mysql_mycnf_version="4.1" 701 mysql_mycnf_version="4.1"
699 else 702 else
700 mysql_mycnf_version="4.0" 703 mysql_mycnf_version="4.0"
701 fi 704 fi
702 insinto "${MY_SYSCONFDIR}" 705 insinto "${MY_SYSCONFDIR}"
703 doins scripts/mysqlaccess.conf 706 doins scripts/mysqlaccess.conf
704 sed -e "s!@MY_SUFFIX@!${MY_SUFFIX}!g" \
705 -e "s!@DATADIR@!${DATADIR}!g" \ 707 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
706 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 708 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \
707 > "${TMPDIR}/my.cnf.ok" 709 > "${TMPDIR}/my.cnf.ok"
708 if mysql_version_is_at_least "4.1" && useq "latin1" ; then 710 if mysql_version_is_at_least "4.1" && use latin1 ; then
709 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 711 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok"
710 fi 712 fi
711 newins "${TMPDIR}/my.cnf.ok" my.cnf 713 newins "${TMPDIR}/my.cnf.ok" my.cnf
712 714
713 # Minimal builds don't have the MySQL server 715 # Minimal builds don't have the MySQL server
714 if ! useq "minimal" ; then 716 if ! use minimal ; then
715 # Empty directories ... 717 # Empty directories ...
716 diropts "-m0750" 718 diropts "-m0750"
717 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then 719 if [[ "${PREVIOUS_DATADIR}" != "yes" ]] ; then
718 dodir "${DATADIR}" 720 dodir "${MY_DATADIR}"
719 keepdir "${DATADIR}" 721 keepdir "${MY_DATADIR}"
720 chown -R mysql:mysql "${D}/${DATADIR}" 722 chown -R mysql:mysql "${D}/${MY_DATADIR}"
721 fi 723 fi
722 724
723 diropts "-m0755" 725 diropts "-m0755"
724 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do 726 for folder in "${MY_LOGDIR}" "/var/run/mysqld" ; do
725 dodir "${folder}" 727 dodir "${folder}"
728 done 730 done
729 fi 731 fi
730 732
731 # Docs 733 # Docs
732 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 734 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE
735 doinfo "${S}"/Docs/mysql.info
733 736
734 # Minimal builds don't have the MySQL server 737 # Minimal builds don't have the MySQL server
735 if ! useq "minimal" ; then 738 if ! use minimal ; then
739 docinto "support-files"
740 for script in \
741 "${S}"/support-files/my-*.cnf \
742 "${S}"/support-files/magic \
743 "${S}"/support-files/ndb-config-2-node.ini
744 do
745 dodoc "${script}"
746 done
747
748 docinto "scripts"
749 for script in "${S}"/scripts/mysql* ; do
750 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
751 done
752
753 fi
754
755 mysql_lib_symlinks "${D}"
756}
757
758mysql_pkg_preinst() {
759 enewgroup mysql 60 || die "problem adding 'mysql' group"
760 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
761}
762
763mysql_pkg_postinst() {
764 # Make sure the vars are correctly initialized
765 mysql_init_vars
766
767 # Check FEATURES="collision-protect" before removing this
768 [[ -d "${ROOT}/var/log/mysql" ]] || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
769
770 # Secure the logfiles
771 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
772 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
773 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
774
775 # Minimal builds don't have the MySQL server
776 if ! use minimal ; then
736 docinto "support-files" 777 docinto "support-files"
737 for script in \ 778 for script in \
738 support-files/my-*.cnf \ 779 support-files/my-*.cnf \
739 support-files/magic \ 780 support-files/magic \
740 support-files/ndb-config-2-node.ini 781 support-files/ndb-config-2-node.ini
744 785
745 docinto "scripts" 786 docinto "scripts"
746 for script in scripts/mysql* ; do 787 for script in scripts/mysql* ; do
747 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 788 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
748 done 789 done
749 fi
750 790
751 if [[ ${PN} == "mysql-slotted" ]] ; then 791 einfo
752 # MOVED HERE DUE TO BUG #121445 792 elog "You might want to run:"
753 # create a list of files, to be used 793 elog "\"emerge --config =${CATEGORY}/${PF}\""
754 # by external utilities 794 elog "if this is a new install."
755 mkdir -p "${D}/var/lib/eselect/mysql/" 795 einfo
756 local filelist="${D}/var/lib/eselect/mysql/mysql${MY_SUFFIX}.filelist"
757 pushd "${D}/" &>/dev/null
758 find usr/bin/ usr/sbin/ \
759 -type f -name "*${MY_SUFFIX}*" \
760 -and -not -name "mysql_config${MY_SUFFIX}" \
761 > "${filelist}"
762 find usr/share/man \
763 -type f -name "*${MY_SUFFIX}*" \
764 | sed -e 's/$/.gz/' \
765 >> "${filelist}"
766 echo "${MY_SYSCONFDIR#"/"}" >> "${filelist}"
767 echo "${MY_LIBDIR#"/"}" >> "${filelist}"
768 echo "${MY_SHAREDSTATEDIR#"/"}" >> "${filelist}"
769 popd &>/dev/null
770 fi 796 fi
771 797
772 mysql_lib_symlinks "${D}" 798 if mysql_version_is_at_least "5.1.12" && use pbxt ; then
773} 799 # TODO: explain it better
774
775mysql_pkg_preinst() {
776 enewgroup mysql 60 || die "problem adding 'mysql' group"
777 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
778}
779
780mysql_pkg_postinst() {
781 # Make sure the vars are correctly initialized
782 mysql_init_vars
783
784 # Check FEATURES="collision-protect" before removing this
785 [[ -d "${ROOT}/var/log/mysql" ]] \
786 || install -d -m0750 -o mysql -g mysql "${ROOT}${MY_LOGDIR}"
787
788 # Secure the logfiles
789 touch "${ROOT}${MY_LOGDIR}"/mysql.{log,err}
790 chown mysql:mysql "${ROOT}${MY_LOGDIR}"/mysql*
791 chmod 0660 "${ROOT}${MY_LOGDIR}"/mysql*
792
793 # Minimal builds don't have the MySQL server
794 if ! useq "minimal" ; then
795 docinto "support-files"
796 for script in \
797 support-files/my-*.cnf \
798 support-files/magic \
799 support-files/ndb-config-2-node.ini
800 do
801 dodoc "${script}"
802 done
803
804 docinto "scripts"
805 for script in scripts/mysql* ; do
806 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
807 done
808 fi
809
810 einfo "you may want to read slotting upgrade documents in the overlay"
811 if useq "pbxt" && mysql_version_is_at_least "5.1" ; then
812 # TODO tell it better ;-)
813 einfo "mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';" 800 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
814 einfo "CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;" 801 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
815 einfo "if, after that you cannot start the mysql server" 802 elog "if, after that, you cannot start the MySQL server,"
816 einfo "remove the ${MY_DATADIR}/mysql/plugin.* files, then" 803 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
817 einfo "use the mysql upgrade script to restore the table" 804 elog "use the MySQL upgrade script to restore the table"
818 einfo " or " 805 elog "or execute the following SQL command:"
819 einfo "CREATE TABLE IF NOT EXISTS plugin (" 806 elog " CREATE TABLE IF NOT EXISTS plugin ("
820 einfo " name char(64) binary DEFAULT '' NOT NULL," 807 elog " name char(64) binary DEFAULT '' NOT NULL,"
821 einfo " dl char(128) DEFAULT '' NOT NULL," 808 elog " dl char(128) DEFAULT '' NOT NULL,"
822 einfo " PRIMARY KEY (name)" 809 elog " PRIMARY KEY (name)"
823 einfo ") CHARACTER SET utf8 COLLATE utf8_bin;" 810 elog " ) CHARACTER SET utf8 COLLATE utf8_bin;"
824 fi 811 fi
812
825 mysql_check_version_range "4.0 to 5.0.99.99" \ 813 mysql_check_version_range "4.0 to 5.0.99.99" \
826 && useq "berkdb" \ 814 && use berkdb \
827 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 815 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
828} 816}
829 817
830mysql_pkg_config() { 818mysql_pkg_config() {
831 # Make sure the vars are correctly initialized 819 # Make sure the vars are correctly initialized
832 mysql_init_vars 820 mysql_init_vars
833 821
834 [[ -z "${DATADIR}" ]] && die "Sorry, unable to find DATADIR" 822 [[ -z "${MY_DATADIR}" ]] && die "Sorry, unable to find MY_DATADIR"
835 823
836 if built_with_use ${CATEGORY}/${PN} minimal ; then 824 if built_with_use ${CATEGORY}/${PN} minimal ; then
837 die "Minimal builds do NOT include the MySQL server" 825 die "Minimal builds do NOT include the MySQL server"
838 fi 826 fi
839 827
840 local pwd1="a" 828 local pwd1="a"
841 local pwd2="b" 829 local pwd2="b"
842 local maxtry=5 830 local maxtry=5
843 831
844 if [[ -d "${ROOT}/${DATADIR}/mysql" ]] ; then 832 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then
845 ewarn "You have already a MySQL database in place." 833 ewarn "You have already a MySQL database in place."
846 ewarn "(${ROOT}/${DATADIR}/*)" 834 ewarn "(${ROOT}/${MY_DATADIR}/*)"
847 ewarn "Please rename or delete it if you wish to replace it." 835 ewarn "Please rename or delete it if you wish to replace it."
848 die "MySQL database already exists!" 836 die "MySQL database already exists!"
849 fi 837 fi
850 838
851 einfo "Creating the mysql database and setting proper" 839 einfo "Creating the mysql database and setting proper"
870 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \ 858 && cp "${help_tables}" "${TMPDIR}/fill_help_tables.sql" \
871 || touch "${TMPDIR}/fill_help_tables.sql" 859 || touch "${TMPDIR}/fill_help_tables.sql"
872 help_tables="${TMPDIR}/fill_help_tables.sql" 860 help_tables="${TMPDIR}/fill_help_tables.sql"
873 861
874 pushd "${TMPDIR}" &>/dev/null 862 pushd "${TMPDIR}" &>/dev/null
875 "${ROOT}/usr/bin/mysql_install_db" | grep -B5 -A999 -i "ERROR" 863 "${ROOT}/usr/bin/mysql_install_db" >"${TMPDIR}"/mysql_install_db.log 2>&1
864 if [ $? -ne 0 ]; then
865 grep -B5 -A999 -i "ERROR" "${TMPDIR}"/mysql_install_db.log 1>&2
866 die "Failed to run mysql_install_db. Please review /var/log/mysql/mysqld.err AND ${TMPDIR}/mysql_install_db.log"
867 fi
876 popd &>/dev/null 868 popd &>/dev/null
877 [[ -f "${ROOT}/${DATADIR}/mysql/user.frm" ]] \ 869 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
878 || die "MySQL databases not installed" 870 || die "MySQL databases not installed"
879 chown -R mysql:mysql "${ROOT}/${DATADIR}" 2> /dev/null 871 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null
880 chmod 0750 "${ROOT}/${DATADIR}" 2> /dev/null 872 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null
881 873
882 if mysql_version_is_at_least "4.1.3" ; then 874 if mysql_version_is_at_least "4.1.3" ; then
883 options="--skip-ndbcluster" 875 options="--skip-ndbcluster"
884 876
885 # Filling timezones, see 877 # Filling timezones, see
896 local mysqld="${ROOT}/usr/sbin/mysqld \ 888 local mysqld="${ROOT}/usr/sbin/mysqld \
897 ${options} \ 889 ${options} \
898 --user=mysql \ 890 --user=mysql \
899 --skip-grant-tables \ 891 --skip-grant-tables \
900 --basedir=${ROOT}/usr \ 892 --basedir=${ROOT}/usr \
901 --datadir=${ROOT}/${DATADIR} \ 893 --datadir=${ROOT}/${MY_DATADIR} \
902 --skip-innodb \ 894 --skip-innodb \
903 --skip-bdb \ 895 --skip-bdb \
904 --skip-networking \ 896 --skip-networking \
905 --max_allowed_packet=8M \ 897 --max_allowed_packet=8M \
906 --net_buffer_length=16K \ 898 --net_buffer_length=16K \
936 wait %1 928 wait %1
937 einfo "Done" 929 einfo "Done"
938} 930}
939 931
940mysql_pkg_postrm() { 932mysql_pkg_postrm() {
941 if [[ ${PN} == "mysql-slotted" ]] ; then
942 mysql_lib_symlinks 933 : # mysql_lib_symlinks "${D}"
943 mysql_clients_link_to_best_version
944 fi
945} 934}

Legend:
Removed from v.1.58  
changed lines
  Added in v.1.98

  ViewVC Help
Powered by ViewVC 1.1.20